---
title: Firefox 71 for Developers
slug: Mozilla/Firefox/Releases/71
tags:
  - '71'
  - Firefox
  - Mozilla
  - Release
---
<p>{{FirefoxSidebar}}</p>

<p class="summary">This article provides information about the changes in Firefox 71 that will affect developers. Firefox 71 was released on December 3, 2019.</p>

<h2 id="Changes_for_web_developers">Changes for web developers</h2>

<h3 id="Developer_tools">Developer tools</h3>

<p><a href="/en-US/docs/Tools/Web_Console">Console</a>:</p>

<ul>
 <li>The Console's <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Multi-line_mode">multi-line mode</a> is now available by default.</li>
 <li>Console configuration options are now combined in a new <a href="/en-US/docs/Tools/Web_Console/Opening_the_Web_Console#Toolbar">toolbar settings menu</a> ({{bug(1523868)}}).</li>
</ul>

<p><a href="/en-US/docs/Tools/Debugger">JavaScript debugger</a>:</p>

<ul>
 <li><a href="/en-US/docs/Tools/Debugger/How_to/Set_a_breakpoint#Inline_variable_preview">Inline variable preview</a> has been enabled ({{bug(1576679)}}).</li>
 <li><a href="/en-US/docs/Tools/Debugger/Set_event_listener_breakpoints#Logging_on_events">Logging on events</a> is now available ({{bug(1110276)}}), as is the ability to <a href="/en-US/docs/Tools/Debugger/Set_event_listener_breakpoints#Filter_by_event_type">filter by event type</a>.</li>
 <li>The new debugger <a href="/en-US/docs/Tools/Debugger/How_to/Step_through_code#Pause_on_breakpoints_overlay">paused overlay</a> can now be disabled using the <code>devtools.debugger.features.overlay</code> pref ({{bug(1579768)}}).</li>
 <li>We've got new <a href="/en-US/docs/Tools/Keyboard_shortcuts">keyboard shortcuts</a> for opening the debugger: <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>Z</kbd> on Linux/Windows and <kbd>Cmd</kbd> + <kbd>Opt</kbd> + <kbd>Z</kbd> on macOS ({{bug(1583042)}}).</li>
 <li>Pausing on a <a href="/en-US/docs/Tools/Debugger/Break_on_DOM_mutation">DOM Mutation Breakpoints</a> now mentions the DOM node that has the breakpoint and, if available, the child node that was added/removed ({{bug(1576145)}}).</li>
 <li>Locations in <a href="/en-US/docs/Tools/Debugger/How_to/Pretty-print_a_minified_file">pretty printed sources</a> are now correct after pretty-printing and when jumping to the source from the Inspector's <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_event_listeners">events listener tooltip</a> ({{bug(1500222)}}).</li>
</ul>

<p><a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>:</p>

<ul>
 <li>The <a href="/en-US/docs/Tools/Network_Monitor/Inspecting_web_sockets">Web sockets inspector</a> is now enabled by default ({{bug(1573805)}}).</li>
 <li>You can now do a <a href="/en-US/docs/Tools/Network_Monitor/request_list#Search_in_requests">full text search</a> of request/response bodies, headers, and cookies.</li>
 <li>You can now enter patterns to <a href="/en-US/docs/Tools/Network_Monitor/request_list#Blocking_specific_URLs">block specific URLs</a> from loading.</li>
 <li>The <a href="/docs/Tools/Network_Monitor/request_details#Timings">Timings tab</a> now exposes timing data sent in the {{httpheader("Server-Timing")}} header ({{bug(1403051)}}).</li>
</ul>

<p><a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>:</p>

<ul>
 <li>Color swatches are now shown next to CSS variable definitions that have color values ({{bug(1456167)}}).</li>
 <li>{{cssxref(":visited")}} styles are now shown in the CSS rules view ({{bug(713106)}}).</li>
</ul>

<h3 id="CSS">CSS</h3>

<ul>
 <li>Added the <a href="/en-US/docs/Web/CSS/CSS_Grid_Layout/Subgrid">subgrid</a> value from CSS Grid Level 2 to {{cssxref("grid-template-columns")}} and {{cssxref("grid-template-rows")}} ({{bug(1580894)}})</li>
 <li>Added support for the {{cssxref("column-span")}} property to <a href="/en-US/docs/Web/CSS/CSS_Columns">Multiple-column Layout</a> ({{bug(1426010)}})</li>
 <li>Added support for the <code>path()</code> value of {{cssxref("clip-path")}} ({{bug(1488530)}})</li>
 <li>Mapped the <code>height</code> and <code>width</code> HTML attributes on the {{htmlelement("img")}} element to an internal {{cssxref("aspect-ratio")}} property ({{bug(1585637)}}). <a href="/en-US/docs/Web/Media/images/aspect_ratio_mapping">See the guide to this feature on MDN</a>.</li>
</ul>

<h4 id="Removals">Removals</h4>

<ul>
 <li>CSS Radial Gradients no longer accept negative radii ({{bug(1583736)}}); also see the <a href="https://www.fxsitecompat.dev/en-CA/docs/2019/css-radial-gradients-no-longer-accept-negative-radii/">site compat note</a>.</li>
</ul>

<h3 id="JavaScript">JavaScript</h3>

<ul>
 <li>The {{jsxref("Promise.allSettled()")}} method is now supported ({{bug(1549176)}}). This method lets you easily wait until every promise in a set of promises has either resolved or rejected before running further code.</li>
</ul>

<h4 id="Removals_2">Removals</h4>

<ul>
 <li>The non-standard Array generic methods have been removed in Firefox 71 ({{bug(1222547)}}). They were first introduced in Firefox 1.5 (<a href="/en-US/docs/Web/JavaScript/New_in_JavaScript/1.6">JavaScript 1.6</a>) and deprecated from Firefox 68 onwards. If your use case is to use array generics on array-like objects, you can convert your object to a proper array using <code><a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/from">Array.from()</a></code> and then use standard array methods.</li>
</ul>

<h3 id="MathML">MathML</h3>

<ul>
 <li><a href="/en-US/docs/Web/MathML/Element">MathML elements</a> now implement a MathML DOM and their class is {{domxref("MathMLElement")}}. With a proper MathML DOM, you can now use <code>mathmlEl.style</code>, or global event handlers, for example. Prior to this change, MathML elements only implemented the {{domxref("Element")}} class ({{bug(1571487)}}).</li>
</ul>

<h3 id="APIs">APIs</h3>

<h4 id="New_APIs">New APIs</h4>

<p>The <a href="/en-US/docs/Web/API/Media_Session_API">Media Session API</a> is now partially implemented. This API provides a standard mechanism for your content to share with the underlying operating system information about the state of media it's playing. This includes metadata such as artist, album, and track name, as well as potentially album artwork ({{bug(1580602)}}).</p>

<p>The API also provides a way to receive notifications when the device's media controls (such as play, pause, and seek buttons) are activated by the user. To that end, the {{domxref("MediaSession")}} interface is now partially implemented, with support for setting and fetching the currently-playing media's metadata. and for the {{domxref("MediaSession.setActionHandler", "setActionHandler()")}} method. To access the <code>MediaSession</code> API, use the {{domxref("navigator.mediaSession")}} property.</p>

<h4 id="DOM">DOM</h4>

<ul>
 <li>The {{domxref("StaticRange.StaticRange()", "StaticRange()")}} constructor is now supported ({{bug(1575980)}}).</li>
 <li>The MathML {{domxref("MathMLElement")}} interface has been implemented ({{bug(1571487)}}).</li>
</ul>

<h4 id="Media_Web_Audio_and_WebRTC">Media, Web Audio, and WebRTC</h4>

<ul>
 <li>The {{domxref("MediaRecorder")}} interface now implements the {{domxref("MediaRecorder.audioBitsPerSecond", "audioBitsPerSecond")}} and {{domxref("MediaRecorder.videoBitsPerSecond", "videoBitsPerSecond")}} properties ({{bug(1514158)}}).</li>
</ul>

<h4 id="Canvas_and_WebGL">Canvas and WebGL</h4>

<ul>
 <li>The {{domxref("OVR_multiview2")}} and {{domxref("OES_fbo_render_mipmap")}} WebGL extensions are now exposed by default ({{bug(1584277)}}, {{bug(1583878)}}).</li>
</ul>

<h4 id="Removals_3">Removals</h4>

<p>The following non-standard {{domxref("DataTransfer")}} members have been removed ({{bug(1345192)}}):</p>

<ul>
 <li>{{domxref("DataTransfer.mozItemCount")}}</li>
 <li>{{domxref("DataTransfer.mozClearDataAt()")}}</li>
 <li>{{domxref("DataTransfer.mozGetDataAt()")}}</li>
 <li>{{domxref("DataTransfer.mozSetDataAt()")}}</li>
 <li>{{domxref("DataTransfer.mozTypesAt()")}}</li>
</ul>

<h3 class="highlight-spanned" id="WebDriver_conformance_Marionette"><span class="highlight-span">WebDriver conformance (Marionette)</span></h3>

<ul>
 <li>Both the <code>WebDriver:TakeScreenshot</code> and <code>WebDriver:TakeElementScreenshot</code> commands have been updated to respect the unhandled prompt behavior setting ({{bug(1584927)}}).</li>
 <li>The command <code>Marionette:Quit</code> has been updated to also allow quitting or restarting of other Gecko-driven applications besides Firefox ({{bug(1298921)}}).</li>
 <li>For GeckoView-based browsers on Android, the returned <code>browserName</code> in the session capabilities will now always be <code>firefox</code> ({{bug(1587364)}}).</li>
</ul>

<h2 id="Changes_for_add-on_developers">Changes for add-on developers</h2>

<h3 id="API_changes">API changes</h3>

<ul>
 <li>{{WebExtAPIRef("downloads.download")}} now identifies and reports as errors the following HTTP response codes:
  <ul>
   <li>404 returning <code>SERVER_BAD_CONTENT</code></li>
   <li>403 returning <code>SERVER_FORBIDDEN</code></li>
   <li>402 and Proxy 407 returning <code>SERVER_UNAUTHORIZED</code></li>
   <li>Anything else above 400 returning <code>SERVER_FAILED</code>  ({{bug(1576333)}})</li>
  </ul>
 </li>
 <li>{{WebExtAPIRef("downloads.download")}} now includes the optional <code>options</code> parameter property <code>allowHttpErrors</code>. When set to <code>true</code>, this <code>boolean</code> flag enables a download to continue after encountering an HTTP error. When set to <code>false</code>, a download is canceled when an HTTP error is encountered. Default value: <code>false</code>. ({{bug(1578955)}})</li>
</ul>

<h4 id="Removals_4">Removals</h4>

<ul>
 <li>The <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/proxy/register" title="This method has been deprecated in Firefox 68 and will be removed from Firefox 71. In Firefox 68 or later, calling this method logs an error message to the console:"><code>proxy.register()</code></a> and <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/API/proxy/unregister" title="This method has been deprecated in Firefox 68 and will be removed from Firefox 71. In Firefox 68 or later, calling this method logs an error message to the console:"><code>proxy.unregister()</code></a> functions have been removed ({{bug(1443259)}}). {{WebExtAPIRef("proxy.onRequest")}} should now be used to handle the proxying of requests.</li>
</ul>

<h2 id="See_also">See also</h2>

<ul>
 <li>Hacks release post: <a href="https://hacks.mozilla.org/2019/12/firefox-71-a-year-end-arrival/">Firefox 71: A year-end arrival</a></li>
 <li><a href="https://www.fxsitecompat.com/en-CA/versions/71/">Site compatibility for Firefox 71</a></li>
</ul>

<h2 id="Older_versions">Older versions</h2>

<p>{{Firefox_for_developers(70)}}</p>
